unit CompareTestMain;

{$mode objfpc}{$H-}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, Grids,
  Buttons, StdCtrls, ExtCtrls, fphashlistsort, DbgTimer;

type

  { TForm1 }

  TForm1 = class(TForm)
    Label1 : TLabel;
    Label10 : TLabel;
    Label2 : TLabel;
    Label3 : TLabel;
    Label4 : TLabel;
    Label5 : TLabel;
    Label6 : TLabel;
    Label7 : TLabel;
    Label8 : TLabel;
    Label9 : TLabel;
    OkBtn : TBitBtn;
    CloseBtn : TBitBtn;
    Grid : TStringGrid;
    Panel1 : TPanel;
    procedure GridPrepareCanvas(sender : TObject; aCol, aRow : Integer;
      aState : TGridDrawState);
    procedure OkBtnClick(Sender : TObject);
  private
    IsGood   : Boolean;
  public
    { public declarations }
  end;

var
  Form1 : TForm1;

implementation

{$R *.lfm}


{ TForm1 }

procedure TForm1.OkBtnClick(Sender : TObject);
var
  NumLoops   : integer;
  t0, t1     : Extended;
  MainStr30  : ShortString = 'ThislislalStringlwithlghjChars';
  CompStr01  : ShortString = '*hislislalStringlwithlghjChars';
  CompStr05  : ShortString = 'This~islalStringlwithlghjChars';
  CompStr05i : ShortString = 'tHIS*islalStringlwithlghjChars';
  CompStr10  : ShortString = 'Thislisla*StringlwithlghjChars';
  CompStr10i : ShortString = 'tHISLISLA*StringlwithlghjChars';
  CompStr20  : ShortString = 'ThislislalStringlwi*hlghjChars';
  CompStr20L : ShortString = 'ThislislalStringlwi';
  CompStr20i : ShortString = 'tHISLISLALsTRINGLWI*hlghjChars';
  CompStr30i : ShortString = 'tHISLISLALsTRINGLWITHLGHJcHARS';

  procedure RunLoop(const S2: ShortString; Sensitive: Boolean; row: integer; txt: String);
  var
    i, n : LongInt;
    f : Extended;
    S0 : String;
  begin
    if Sensitive then
    begin
      Grid.Cells[0, row] := 'Sensitive';
      DebugTimerStart;
      for i := 1 to NumLoops do
        n := CompareStr(MainStr30, S2);
      t0 := DebugTimerStop;
      S0 := DebugTimeTotal;
      DebugTimerStart;
      for i := 1 to NumLoops do
        n := CompareShortStringAnsiCharSensitive(MainStr30, S2);
      t1 := DebugTimerStop;
    end
    else begin
      Grid.Cells[0, row] := 'Insensitive';
      DebugTimerStart;
      for i := 1 to NumLoops do
        n := CompareText(MainStr30, S2);
      t0 := DebugTimerStop;
      S0 := DebugTimeTotal;
      DebugTimerStart;
      for i := 1 to NumLoops do
        n := CompareShortStringAnsiCharInsensitive(MainStr30, S2);
      t1 := DebugTimerStop;
    end;
    f := t0/t1;
    IsGood := f > 1;
    Grid.Cells[1, row] := txt;
    Grid.Cells[2, row] := S0;
    Grid.Cells[3, row] := DebugTimeTotal;
    Grid.Cells[4, row] := format('%.2f',[f]);
    Application.ProcessMessages;
  end;

begin
  NumLoops := 10000000;
  Grid.Clean;
  Application.ProcessMessages;
  RunLoop(CompStr01,  true,  1,  'Mismatch at 1');
  RunLoop(CompStr05,  true,  2,  'Mismatch at 5');
  RunLoop(CompStr10,  true,  3,  'Mismatch at 10');
  RunLoop(CompStr20,  true,  4,  'Mismatch at 20');
  RunLoop(CompStr20L, true,  5,  'Length Mismatch at 20');
  RunLoop(MainStr30,  true,  6,  'Match with 30');
  RunLoop(CompStr01,  false, 7,  'Mismatch at 1');
  RunLoop(CompStr05,  false, 8,  'Mismatch at 5, no inv.');
  RunLoop(CompStr05i, false, 9,  'Mismatch at 5, all inv.');
  RunLoop(CompStr10,  false, 10, 'Mismatch at 10, no inv.');
  RunLoop(CompStr10i, false, 11, 'Mismatch at 10, all inv.');
  RunLoop(CompStr20,  false, 12, 'Mismatch at 20, no inv.');
  RunLoop(CompStr20i, false, 13, 'Mismatch at 20, all inv.');
  RunLoop(CompStr20L, false, 14, 'Length Mismatch at 20');
  RunLoop(MainStr30,  false, 15, 'Match with 30, no inv.');
  RunLoop(CompStr30i, false, 16, 'Match with 30, all inv.');
end;

procedure TForm1.GridPrepareCanvas(sender : TObject; aCol, aRow : Integer;
  aState : TGridDrawState);
begin
  if aRow in [1..6] then Grid.Canvas.Brush.Color := $C8E6F9
  else if aRow in [9, 11, 13, 16] then Grid.Canvas.Brush.Color := $F7EFA8
    else if aRow <> 0 then Grid.Canvas.Brush.Color := $DCF3DC;
  if (aCol < 2) or (aRow = 0) then Grid.Canvas.Font.Color := clBlack
  else if ((aCol = 2) and IsGood) or ((aCol > 2) and not IsGood) then
    Grid.Canvas.Font.Color := clRed
    else Grid.Canvas.Font.Color := clGreen;
end;

end.

